#include <sourcemod>
#include <sdkhooks>
#include <sdktools>
#include <multicolors>
#include <autoexecconfig>

#pragma semicolon 1

#define DEBUG

#pragma newdecls required

public Plugin myinfo = 
{
	name = "Host and Code - Grenades Messages", 
	author = "Host and Code", 
	description = "Host and Code - Throw and Detonate Grenades Messages on Chat", 
	version = "1.0", 
	url = "https://steamcommunity.com/id/lantejoula/"
};

char g_ChatPrefix[256]; //USAR ESTE
ConVar gConVar_Chat_Prefix;

ConVar gConVar_Type_Throw_Message;

ConVar gConVar_Type_Detonate_Message;

ConVar gConVar_Prefix;

char g_RemoveDefaultsThrowGrenadesMessages[][] = 
{
	"#SFUI_TitlesTXT_Fire_in_the_hole", 
	"#SFUI_TitlesTXT_Flashbang_in_the_hole", 
	"#SFUI_TitlesTXT_Smoke_in_the_hole", 
	"#SFUI_TitlesTXT_Decoy_in_the_hole", 
	"#SFUI_TitlesTXT_Molotov_in_the_hole", 
	"#SFUI_TitlesTXT_Incendiary_in_the_hole"
};

public void OnPluginStart()
{
	LoadTranslations("bananagaminggrenadesmessages.phrases");
	
	AutoExecConfig_SetFile("plugin.bananagaminggrenadesmessages");
	
	gConVar_Chat_Prefix = AutoExecConfig_CreateConVar("sm_bananagaminggrenadesmessages_chat_prefix", "[{green}TAG{default}] ", "Chat Prefix - ( Dont Remove Last Space After ] )");
	
	gConVar_Type_Throw_Message = AutoExecConfig_CreateConVar("sm_bananagaminggrenadesmessages_type_throw_message", "2", "Type of Message When Someone Throw Grenade (0 - Disable | 1 - Chat of Player | 2 - Team Chat | 3 - Global Chat)", 0, true, 0.0, true, 3.0);
	
	gConVar_Type_Detonate_Message = AutoExecConfig_CreateConVar("sm_bananagaminggrenadesmessages_type_detonate_message", "2", "Type of Message When Grenade is Detonate (0 - Disable | 1 - Chat of Player | 2 - Team Chat | 3 - Global Chat)", 0, true, 0.0, true, 3.0);
	
	gConVar_Prefix = AutoExecConfig_CreateConVar("sm_bananagaminggrenadesmessages_prefix", "1", "Enable/Disable Prefix on Throw and Detonate Grenadas Message on Chat (0 - Disable | 1 - Enable)", 0, true, 0.0, true, 3.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	gConVar_Chat_Prefix.AddChangeHook(OnPrefixChange);
	
	HookEvent("hegrenade_detonate", hegrenade_detonate);
	HookEvent("flashbang_detonate", flashbang_detonate);
	HookEvent("molotov_detonate", molotov_detonate);
	HookEvent("smokegrenade_detonate", smokegrenade_detonate);
	HookEvent("decoy_detonate", decoy_detonate);
	
	HookUserMessage(GetUserMessageId("RadioText"), OnHookTextMsg, true);
}

//Prefix

public void SavePrefix()
{
	GetConVarString(gConVar_Chat_Prefix, g_ChatPrefix, sizeof(g_ChatPrefix));
}

public void OnConfigsExecuted()
{
	SavePrefix();
}

public void OnPrefixChange(ConVar cvar, char[] oldvalue, char[] newvalue)
{
	SavePrefix();
}

//DETONATE GREANADES
//DETONATE GREANADES
//DETONATE GREANADES

// (0 - Disable | 1 - Chat of Player | 2 - Team Chat | 3 - Global Chat)

public void hegrenade_detonate(Event event, const char[] name, bool dontBroadcast)
{
	int thrower = GetClientOfUserId(event.GetInt("userid"));
	
	if (gConVar_Type_Detonate_Message.IntValue == 0)
	{
		return;
	}
	if (gConVar_Type_Detonate_Message.IntValue == 1)
	{
		char grenade[MAX_NAME_LENGTH + 32];
		Format(grenade, sizeof(grenade), "%t", "DetonateHEMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChat(thrower, grenade);
	}
	if (gConVar_Type_Detonate_Message.IntValue == 2)
	{
		char grenade1[MAX_NAME_LENGTH + 32];
		Format(grenade1, sizeof(grenade1), "%t", "DetonateHEMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		PrintToTeam(GetClientTeam(thrower), grenade1);
	}
	if (gConVar_Type_Detonate_Message.IntValue == 3)
	{
		char grenade2[MAX_NAME_LENGTH + 32];
		Format(grenade2, sizeof(grenade2), "%t", "DetonateHEMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChatAll(grenade2);
	}
}

public void flashbang_detonate(Event event, const char[] name, bool dontBroadcast)
{
	int thrower = GetClientOfUserId(event.GetInt("userid"));
	
	if (gConVar_Type_Detonate_Message.IntValue == 0)
	{
		return;
	}
	if (gConVar_Type_Detonate_Message.IntValue == 1)
	{
		char grenade3[MAX_NAME_LENGTH + 32];
		Format(grenade3, sizeof(grenade3), "%t", "DetonateFlashMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChat(thrower, grenade3);
	}
	if (gConVar_Type_Detonate_Message.IntValue == 2)
	{
		char grenade4[MAX_NAME_LENGTH + 32];
		Format(grenade4, sizeof(grenade4), "%t", "DetonateFlashMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		PrintToTeam(GetClientTeam(thrower), grenade4);
	}
	if (gConVar_Type_Detonate_Message.IntValue == 3)
	{
		char grenade5[MAX_NAME_LENGTH + 32];
		Format(grenade5, sizeof(grenade5), "%t", "DetonateFlashMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChatAll(grenade5);
	}
}

public void smokegrenade_detonate(Event event, const char[] name, bool dontBroadcast)
{
	int thrower = GetClientOfUserId(event.GetInt("userid"));
	
	if (gConVar_Type_Detonate_Message.IntValue == 0)
	{
		return;
	}
	if (gConVar_Type_Detonate_Message.IntValue == 1)
	{
		char grenade6[MAX_NAME_LENGTH + 32];
		Format(grenade6, sizeof(grenade6), "%t", "DetonateSmokeMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChat(thrower, grenade6);
	}
	if (gConVar_Type_Detonate_Message.IntValue == 2)
	{
		char grenade7[MAX_NAME_LENGTH + 32];
		Format(grenade7, sizeof(grenade7), "%t", "DetonateSmokeMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		PrintToTeam(GetClientTeam(thrower), grenade7);
	}
	if (gConVar_Type_Detonate_Message.IntValue == 3)
	{
		char grenade8[MAX_NAME_LENGTH + 32];
		Format(grenade8, sizeof(grenade8), "%t", "DetonateSmokeMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChatAll(grenade8);
	}
}

public void decoy_detonate(Event event, const char[] name, bool dontBroadcast)
{
	int thrower = GetClientOfUserId(event.GetInt("userid"));
	
	if (gConVar_Type_Detonate_Message.IntValue == 0)
	{
		return;
	}
	if (gConVar_Type_Detonate_Message.IntValue == 1)
	{
		char grenade9[MAX_NAME_LENGTH + 32];
		Format(grenade9, sizeof(grenade9), "%t", "DetonateDecoyMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChat(thrower, grenade9);
	}
	if (gConVar_Type_Detonate_Message.IntValue == 2)
	{
		char grenade9[MAX_NAME_LENGTH + 32];
		Format(grenade9, sizeof(grenade9), "%t", "DetonateDecoyMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		PrintToTeam(GetClientTeam(thrower), grenade9);
	}
	if (gConVar_Type_Detonate_Message.IntValue == 3)
	{
		char grenade10[MAX_NAME_LENGTH + 32];
		Format(grenade10, sizeof(grenade10), "%t", "DetonateDecoyMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChatAll(grenade10);
	}
}

public void molotov_detonate(Event event, const char[] name, bool dontBroadcast)
{
	int thrower = GetClientOfUserId(event.GetInt("userid"));
	
	if (gConVar_Type_Detonate_Message.IntValue == 0)
	{
		return;
	}
	if (gConVar_Type_Detonate_Message.IntValue == 1)
	{
		char grenade11[MAX_NAME_LENGTH + 32];
		Format(grenade11, sizeof(grenade11), "%t", "DetonateMolotovIncMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChat(thrower, grenade11);
	}
	if (gConVar_Type_Detonate_Message.IntValue == 2)
	{
		char grenade12[MAX_NAME_LENGTH + 32];
		Format(grenade12, sizeof(grenade12), "%t", "DetonateMolotovIncMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		PrintToTeam(GetClientTeam(thrower), grenade12);
	}
	if (gConVar_Type_Detonate_Message.IntValue == 3)
	{
		char grenade13[MAX_NAME_LENGTH + 32];
		Format(grenade13, sizeof(grenade13), "%t", "DetonateMolotovIncMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChatAll(grenade13);
	}
}

//OnEntityCreated
//OnEntityCreated
//OnEntityCreated

public void OnEntityCreated(int entity, const char[] Classname)
{
	if (StrEqual(Classname, "molotov_projectile") || StrEqual(Classname, "pipe_bomb_projectile") || StrEqual(Classname, "vomitjar_projectile"))
	{
		SDKHook(entity, SDKHook_SpawnPost, SpawnPost_GrenadeMolotov);
	}
	if (StrEqual(Classname, "incgrenade_projectile") || StrEqual(Classname, "pipe_bomb_projectile") || StrEqual(Classname, "vomitjar_projectile"))
	{
		SDKHook(entity, SDKHook_SpawnPost, SpawnPost_GrenadeIncGrenade);
	}
	if (StrEqual(Classname, "hegrenade_projectile") || StrEqual(Classname, "pipe_bomb_projectile") || StrEqual(Classname, "vomitjar_projectile"))
	{
		SDKHook(entity, SDKHook_SpawnPost, SpawnPost_GrenadeHE);
	}
	if (StrEqual(Classname, "smokegrenade_projectile") || StrEqual(Classname, "pipe_bomb_projectile") || StrEqual(Classname, "vomitjar_projectile"))
	{
		SDKHook(entity, SDKHook_SpawnPost, SpawnPost_GrenadeSmoke);
	}
	if (StrEqual(Classname, "flashbang_projectile") || StrEqual(Classname, "pipe_bomb_projectile") || StrEqual(Classname, "vomitjar_projectile"))
	{
		SDKHook(entity, SDKHook_SpawnPost, SpawnPost_GrenadeFlashBang);
	}
	if (StrEqual(Classname, "decoy_projectile") || StrEqual(Classname, "pipe_bomb_projectile") || StrEqual(Classname, "vomitjar_projectile"))
	{
		SDKHook(entity, SDKHook_SpawnPost, SpawnPost_GrenadeDecoy);
	}
}

//THROW GREANADES
//THROW GREANADES
//THROW GREANADES

// (0 - Disable | 1 - Chat of Player | 2 - Team Chat | 3 - Global Chat)

public void SpawnPost_GrenadeMolotov(int entity)
{
	SDKUnhook(entity, SDKHook_SpawnPost, SpawnPost_GrenadeMolotov);
	
	int thrower = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
	
	if (gConVar_Type_Throw_Message.IntValue == 0)
	{
		return;
	}
	if (gConVar_Type_Throw_Message.IntValue == 1)
	{
		char grenade14[MAX_NAME_LENGTH + 32];
		Format(grenade14, sizeof(grenade14), "%t", "ThrowMolotovMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChat(thrower, grenade14);
	}
	if (gConVar_Type_Throw_Message.IntValue == 2)
	{
		char grenade15[MAX_NAME_LENGTH + 32];
		Format(grenade15, sizeof(grenade15), "%t", "ThrowMolotovMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		PrintToTeam(GetClientTeam(thrower), grenade15);
	}
	if (gConVar_Type_Throw_Message.IntValue == 3)
	{
		char grenade16[MAX_NAME_LENGTH + 32];
		Format(grenade16, sizeof(grenade16), "%t", "ThrowMolotovMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChatAll(grenade16);
	}
}

public void SpawnPost_GrenadeIncGrenade(int entity)
{
	SDKUnhook(entity, SDKHook_SpawnPost, SpawnPost_GrenadeIncGrenade);
	
	int thrower = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
	
	if (gConVar_Type_Throw_Message.IntValue == 0)
	{
		return;
	}
	if (gConVar_Type_Throw_Message.IntValue == 1)
	{
		char grenade17[MAX_NAME_LENGTH + 32];
		Format(grenade17, sizeof(grenade17), "%t", "ThrowIncMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChat(thrower, grenade17);
	}
	if (gConVar_Type_Throw_Message.IntValue == 2)
	{
		char grenade18[MAX_NAME_LENGTH + 32];
		Format(grenade18, sizeof(grenade18), "%t", "ThrowIncMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		PrintToTeam(GetClientTeam(thrower), grenade18);
	}
	if (gConVar_Type_Throw_Message.IntValue == 3)
	{
		char grenade19[MAX_NAME_LENGTH + 32];
		Format(grenade19, sizeof(grenade19), "%t", "ThrowIncMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChatAll(grenade19);
	}
}

public void SpawnPost_GrenadeHE(int entity)
{
	SDKUnhook(entity, SDKHook_SpawnPost, SpawnPost_GrenadeHE);
	
	int thrower = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
	
	if (gConVar_Type_Throw_Message.IntValue == 0)
	{
		return;
	}
	if (gConVar_Type_Throw_Message.IntValue == 1)
	{
		char grenade20[MAX_NAME_LENGTH + 32];
		Format(grenade20, sizeof(grenade20), "%t", "ThrowHEMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChat(thrower, grenade20);
	}
	if (gConVar_Type_Throw_Message.IntValue == 2)
	{
		char grenade21[MAX_NAME_LENGTH + 32];
		Format(grenade21, sizeof(grenade21), "%t", "ThrowHEMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		PrintToTeam(GetClientTeam(thrower), grenade21);
	}
	if (gConVar_Type_Throw_Message.IntValue == 3)
	{
		char grenade22[MAX_NAME_LENGTH + 32];
		Format(grenade22, sizeof(grenade22), "%t", "ThrowHEMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChatAll(grenade22);
	}
}

public void SpawnPost_GrenadeSmoke(int entity)
{
	SDKUnhook(entity, SDKHook_SpawnPost, SpawnPost_GrenadeSmoke);
	
	int thrower = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
	
	if (gConVar_Type_Throw_Message.IntValue == 0)
	{
		return;
	}
	if (gConVar_Type_Throw_Message.IntValue == 1)
	{
		char grenade23[MAX_NAME_LENGTH + 32];
		Format(grenade23, sizeof(grenade23), "%t", "ThrowSmokeMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChat(thrower, grenade23);
	}
	if (gConVar_Type_Throw_Message.IntValue == 2)
	{
		char grenade24[MAX_NAME_LENGTH + 32];
		Format(grenade24, sizeof(grenade24), "%t", "ThrowSmokeMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		PrintToTeam(GetClientTeam(thrower), grenade24);
	}
	if (gConVar_Type_Throw_Message.IntValue == 3)
	{
		char grenade25[MAX_NAME_LENGTH + 32];
		Format(grenade25, sizeof(grenade25), "%t", "ThrowSmokeMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChatAll(grenade25);
	}
}

public void SpawnPost_GrenadeFlashBang(int entity)
{
	SDKUnhook(entity, SDKHook_SpawnPost, SpawnPost_GrenadeFlashBang);
	
	int thrower = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
	
	if (gConVar_Type_Throw_Message.IntValue == 0)
	{
		return;
	}
	if (gConVar_Type_Throw_Message.IntValue == 1)
	{
		char grenade26[MAX_NAME_LENGTH + 32];
		Format(grenade26, sizeof(grenade26), "%t", "ThrowFlashMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChat(thrower, grenade26);
	}
	if (gConVar_Type_Throw_Message.IntValue == 2)
	{
		char grenade27[MAX_NAME_LENGTH + 32];
		Format(grenade27, sizeof(grenade27), "%t", "ThrowFlashMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		PrintToTeam(GetClientTeam(thrower), grenade27);
	}
	if (gConVar_Type_Throw_Message.IntValue == 3)
	{
		char grenade28[MAX_NAME_LENGTH + 32];
		Format(grenade28, sizeof(grenade28), "%t", "ThrowFlashMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChatAll(grenade28);
	}
}

public void SpawnPost_GrenadeDecoy(int entity)
{
	SDKUnhook(entity, SDKHook_SpawnPost, SpawnPost_GrenadeDecoy);
	
	int thrower = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
	
	if (gConVar_Type_Throw_Message.IntValue == 0)
	{
		return;
	}
	if (gConVar_Type_Throw_Message.IntValue == 1)
	{
		char grenade29[MAX_NAME_LENGTH + 32];
		Format(grenade29, sizeof(grenade29), "%t", "ThrowDecoyMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChat(thrower, grenade29);
	}
	if (gConVar_Type_Throw_Message.IntValue == 2)
	{
		char grenade30[MAX_NAME_LENGTH + 32];
		Format(grenade30, sizeof(grenade30), "%t", "ThrowDecoyMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		PrintToTeam(GetClientTeam(thrower), grenade30);
	}
	if (gConVar_Type_Throw_Message.IntValue == 3)
	{
		char grenade31[MAX_NAME_LENGTH + 32];
		Format(grenade31, sizeof(grenade31), "%t", "ThrowDecoyMessage", gConVar_Prefix.BoolValue ? g_ChatPrefix:"", thrower);
		CPrintToChatAll(grenade31);
	}
}

//PRINT TO TEAM
//PRINT TO TEAM
//PRINT TO TEAM

void PrintToTeam(int team_index, const char[] msg)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsValidClient(i) == true && GetClientTeam(i) == team_index)
		{
			CPrintToChat(i, "%s", msg);
		}
	}
}

//REMOVE DEFAULTS THROW GRENADES MESSAGES
//REMOVE DEFAULTS THROW GRENADES MESSAGES
//REMOVE DEFAULTS THROW GRENADES MESSAGES

public Action OnHookTextMsg(UserMsg msg_id, Handle bf, int[] players, int playersNum, bool reliable, bool init)
{
	char sBuffer[64];
	PbReadString(bf, "params", sBuffer, sizeof(sBuffer), 2);
	
	for (int i = 0; i < sizeof(g_RemoveDefaultsThrowGrenadesMessages); i++)
	{
		if (!strcmp(sBuffer, g_RemoveDefaultsThrowGrenadesMessages[i], false))
		{
			return Plugin_Handled;
		}
	}
	
	return Plugin_Continue;
}

//IsValidClient
//IsValidClient
//IsValidClient

stock bool IsValidClient(int client)
{
	return (1 <= client <= MaxClients && IsClientInGame(client) && !IsClientSourceTV(client));
} 